<template>
  <div class="row">
    <div class="row__top">
      <div class="category">
        <div class="category__title">{{ $t('sidebar_title.project') }}</div>
        <nav class="category__ul">
          <ul>
            <li v-for="(item, index) in menuItems" :key="index">
              <a :href="item.url" target="_blank" v-if="item.external">
                {{ getMenuTitle(item) }}
              </a>
              <nuxt-link :to="localePath(item.url)" v-else>
                {{ getMenuTitle(item) }}
              </nuxt-link>
            </li>
          </ul>
        </nav>
      </div>
      <div class="category">
        <div class="category__title">{{ $t('sidebar_title.social') }}</div>
        <div class="category__ul">
          <ul>
            <li v-for="(item, index) in socialMenuItems" :key="index">
              <a :href="item.url" target="_blank" v-if="item.external">
                {{ getMenuTitle(item) }}
              </a>
              <nuxt-link :to="localePath(item.url)" v-else>
                {{ getMenuTitle(item) }}
              </nuxt-link>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <div class="row__bottom">
      <div class="hide-desktop">
        <MobileApp position="header" />
      </div>
      <div>
        <LangSwitch />
      </div>
      <div class="row__btn">
        <Button :to="localePath('/auth')" variant="success">
          {{ $t('login_reg') }}
        </Button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, useAsync, computed } from '@nuxtjs/composition-api'
import useGetLocales from '@/hooks/get-locales'
import getMenuTitle from '@/hooks/get-menu-title'

import { AppEvents } from '~/types'
import { useGetMenuItemsQuery } from '~/sdk/hooks'
import { Menu_Type_Enum, MenuItemWithLocalizationFragment } from '@/sdk/types'

import MobileApp from '@/components/app/MobileApp.vue'
import LangSwitch from '@/components/app/LangSwitch.vue'
import Button from '@/components/ui/Button.vue'

export default defineComponent({
  name: 'SidebarMenu',
  components: { LangSwitch, Button, MobileApp },
  setup(_, { root }) {
    const { onResult, refetch } = useGetMenuItemsQuery({
      types: [Menu_Type_Enum.Sidebar, Menu_Type_Enum.SidebarSocial],
      locales: useGetLocales(root.$i18n)
    })

    const menu = useAsync<MenuItemWithLocalizationFragment[]>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            resolve(result?.data?.menu || [])
          })
        )
    )

    if (process.client) {
      root.$on(AppEvents.LocaleChanged, () => {
        refetch({
          types: [Menu_Type_Enum.Sidebar, Menu_Type_Enum.SidebarSocial],
          locales: useGetLocales(root.$i18n)
        })
      })

      onResult(result => {
        menu.value = result?.data?.menu ?? []
      })
    }

    const menuItems = computed(() =>
      (menu.value || []).filter(i => i.type === Menu_Type_Enum.Sidebar)
    )

    const socialMenuItems = computed(() =>
      (menu.value || []).filter(i => i.type === Menu_Type_Enum.SidebarSocial)
    )

    return {
      menuItems,
      socialMenuItems,
      getMenuTitle
    }
  }
})
</script>

<style lang="scss" scoped>
.row {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  min-height: 100%;

  &__bottom {
    padding-top: 40px;
    &::v-deep {
      .main-app {
        display: block;
        &__icon {
          margin-bottom: 15px;
          img,
          svg {
            width: 60px;
            height: 60px;
          }
        }
        &__title {
          margin-bottom: 20px !important;
          font-size: 24px !important;
          line-height: 30px !important;
        }
        &__link {
          margin-bottom: 20px;
          > div {
            margin-bottom: 15px;
          }

          @media (min-width: 355px) {
            display: flex;
            margin-right: -15px;
            margin-bottom: 25px;
            > div {
              padding-right: 15px;
              flex: 1;
              margin-bottom: 0px;
            }
          }

          &-item {
            font-size: 20px;
            line-height: 28px;
            padding: 15px;
          }
        }
      }
    }
  }
  &__btn {
    margin-top: 25px;
  }
}

.category {
  margin: 0 0 30px 0;
  &:last-child {
    margin-bottom: 0;
  }

  @media (min-width: 1199.98px) {
    margin-bottom: 50px;
  }

  &__title {
    font-size: 20px;
    line-height: 25px;
    font-weight: bold;
    letter-spacing: 1px;
    color: #ffffff;
    text-transform: uppercase;
    margin-bottom: 20px;
    @media (min-width: 1199.98px) {
      font-size: 24px;
      line-height: 30px;
      letter-spacing: 1.2px;
    }
  }
  &__ul {
    ul {
      margin: 0;
      padding: 0;
      list-style: none;
      li {
        margin-bottom: 8px;
        font-size: 0px;
        &:last-child {
          margin-bottom: 0px;
        }
        a {
          font-size: 24px;
          line-height: 30px;
          color: #9badd6;
          text-decoration: none;
          transition: 0.25s all linear;
          &:hover,
          &.is-active {
            color: #fff;
          }
        }
      }
    }
  }
}
</style>
